/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-20 18:51
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const int MAXN = 1e5 + 5;
ll N, M;

// Algorithms from our reference

// mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
mt19937 gen(1337);                      // seed = 1337; should not return 0 for ra or rb
const ll ra = gen(), rb = gen();        // shall be two random numbers != 0
ll p = (1LL << 31) - 1;                 // prime > |U| - bigger than universe size
ll carter_wegman(ll a){                 // p = (1LL << 61) - 1 is another Mersenne prime
    return (ra * a + rb) % p;
}
template<>                              // hash function for pair<int,int>
struct std::hash<pair<int,int>> {       // now e.g. unordered_map can be instantiated
    size_t operator()(pair<int,int> a) const {
        ll tmp = (ll)a.first << 32 | (unsigned)a.second;
        return carter_wegman(tmp);      // important to call carter-wegman(tmp) before return
    }
};


// union find
int parent[MAXN], rnk[MAXN];
void make(int v) {
  parent[v] = v;
}// alt init: iota(parent, parent + MAXN, 0);
int find(int v) {
  if (v == parent[v]) return v;
  return parent[v] = find(parent[v]);
}
bool merge(int a, int b) {
  a = find(a); b = find(b);
  if(a == b) return false;
  if(rnk[a] < rnk[b]) swap(a,b);
  parent[b] = a;
  if(rnk[a] == rnk[b]) rnk[a]++;
  return true;
}


void IS_BRIDGE(int u, int v, int id);

// dfs-bridges
struct edge { int w, i; };
vector<edge> edges[MAXN];
int tin[MAXN], low[MAXN], t;
void dfs_bridge(int u, int prvid = -1) {
  low[u] = tin[u] = ++t;
  for (auto [v, i] : edges[u])
    if (i == prvid) continue;
    else if (!tin[v]) {
      dfs_bridge(v, i);
      low[u] = min(low[u], low[v]);
      if (tin[u] < low[v])
        IS_BRIDGE(u, v, i);
    } else
      low[u] = min(low[u], tin[v]);
}

vector<pair<int,int>> bridges;
void IS_BRIDGE(int u, int v, int id){
    bridges.emplace_back(u,v);
    bridges.emplace_back(v,u);
}


struct conn {
  int u, v, cost;
};

const int NONE = 0, SOME = 1, ANY = 2;

map<pair<int,int>, int> results;
typedef vector<conn>::iterator vci;
void process(const vci startit, const vci endit){
    unordered_set<int> involved;
    int id = 0;
    for(auto it = startit; it != endit; it++){
        auto [u, v, c] = *it;
        int a = find(u), b = find(v);
        if(a == b) continue;
        involved.emplace(a);
        involved.emplace(b);
        edges[a].emplace_back(b, id);
        edges[b].emplace_back(a, id);
        id++;
    }

    for(int v : involved)
        if (not tin[v])
            dfs_bridge(v);

    /* cerr << "Here are the bridges: "; */
    /* for(auto [a,b] : bridges) */
    /*     fprintf(stderr, "{%d, %d} ", a, b); */
    /* cerr  << endl; */

    unordered_set<pair<int,int>> bri(begin(bridges), end(bridges));
    for(auto it = startit; it != endit; it++){
        auto [u, v, c] = *it;
        int a = find(u), b = find(v);
        if (a == b) {
            results[{u, v}] = NONE;
            continue;
        }
        bool r = bri.contains({a,b});
        results[{u, v}] = r ? ANY : SOME;
    }

    // cleanup
    bridges.clear();
    for(int v: involved){
        edges[v].clear();
        tin[v] = low[v] = 0;
    }
    t = 0;
}

// kruskal
vector<conn> connlist;
int kruskal(int n) {
  for (int i = 0; i < n; i++)
    make(i);
  ranges::sort(connlist, {}, &conn::cost);
  int sumcost = 0;
  auto it = begin(connlist);
  while (it != end(connlist)){
      int curcost = it->cost;
      auto endit = ranges::upper_bound(it, end(connlist), curcost, {}, &conn::cost);
      process(it, endit);
      while(it != endit){
          auto [u, v, cost] = *it;
          if (merge(u, v))
              sumcost += cost;
          it++;
      }
  }
  return sumcost;
}



void solve(){
    // Code goes here ...
    cin >> N >> M;

    vector<pair<int,int>> order;
    int u, v, c;
    R(i, M){
        cin >> u >> v >> c;
        connlist.emplace_back(u, v, c);
        order.emplace_back(u,v);
    }

    kruskal(N+1);

    for(auto e: order){
        switch (results[e]) {
            case NONE:
                cout << "none" << endl;
                break;
            case SOME:
                cout << "at least one" << endl;
                break;
            case ANY:
                cout << "any" << endl;
                break;
        }
    }
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    /* cin >> T; */
    while(T--)
        solve();

    return 0;
}

